
int RPin = 0; // La mesure correspond à un entier et se fait sur le pin Analogique A0
int URnumerise; // On déclare comme un entier la grandeur correspondant à la valeur numérisée de la tension analogique lue aux bornes de R 
int tensionR; // On déclare comme un entier la tension analogique lue aux bornes de R
int masse; // On déclare comme un entier la masse
unsigned long Resistancecapteur; // On déclare comme un entier la resistance du capteur

const float coefficient_directeur = 9.148 / 10000000;// Modifier la valeur du coefficient directeur de la droite 1/Rcapteur en fonction masse en ohms-1 par g

void setup() // initialisation exécuté une seule fois
{
    Serial.begin(9600); // Fixe le débit de communication entre le moniteur serie de la carte et l'ordinateur en nombre de caractères par seconde
}

void loop()// Programme principal exécuté en boucle
{
    URnumerise = analogRead(RPin);// URnumerise correspond à la valeur numérisée de la tension analogique lue en A0 (UR)
    tensionR = map(URnumerise, 0, 1023, 0, 5000);// Convertit la valeur numérisée en une tension analogique en mV
    
    if (tensionR == 0) {
    Serial.println("Pas de masse");
    } 
    else {
    // la tension aux bornes de la résistance UR = tension alimentation x R / (R + Rcapteur) avec R = 10 kohms et tension alimentation = 5V
    // donc la résistance du capteur de force Rcapteur = ((5 - UR) x R) / UR
    Resistancecapteur = 5000 - tensionR; // tensionR est en mV et 5V = 5000 mV
    Resistancecapteur *= 10000; // multiplication par la résistance R=10 kohms
    Resistancecapteur /= tensionR;// division par la tension aux bornes de la résistance
    
    masse = 1 / coefficient_directeur / Resistancecapteur;// m=1/(coef-direct x Rcapteur )
    Serial.print("La masse en g vaut ");// On affiche le texte entre " et "
    Serial.println(masse);// On affiche la valeur de la masse avec un saut de ligne
    
    }
    delay(5000);// Attente de 5 s avant une nouvelle mesure
}
